VERSION 5.00
Begin VB.Form FMain 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "CDChanger"
   ClientHeight    =   2670
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4290
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2670
   ScaleWidth      =   4290
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.Timer tmrTimer 
      Interval        =   1000
      Left            =   338
      Top             =   1895
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "&Close"
      Height          =   340
      Left            =   2378
      TabIndex        =   2
      Top             =   1995
      Width           =   1215
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "&Open"
      Height          =   340
      Left            =   818
      TabIndex        =   1
      Top             =   1995
      Width           =   1215
   End
   Begin VB.ListBox lstDrives 
      Height          =   1425
      Left            =   338
      TabIndex        =   0
      Top             =   335
      Width           =   3615
   End
End
Attribute VB_Name = "FMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
' Bekannte Probleme:
'
'   -  CD-ROM-Laufwerke, die keine physikalischen Laufwerke sind, also virtuelle Laufwerke, fhren zu einem
'      Absturz der Anwendung (bei einem NERO IMAGEDRIVE SCSI CdRom device unter Windows XP).
'
'   -  Ermitteln, ob ein CD-ROM-Laufwerk leer/geffnet ist (Fallunterscheidung).
'
Option Explicit

'**********************************
' Win32 API declares.
'**********************************

Private Declare Function GetVolumeInformation Lib "kernel32.dll" Alias "GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, ByRef lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long
Private Declare Function GetDriveType Lib "kernel32.dll" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
Private Declare Function GetLogicalDriveStrings Lib "kernel32.dll" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

Private Const DRIVE_REMOVABLE As Long = 2&
Private Const DRIVE_FIXED As Long = 3&
Private Const DRIVE_REMOTE As Long = 4&
Private Const DRIVE_CDROM As Long = 5&
Private Const DRIVE_RAMDISK As Long = 6&

Private Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" (ByVal lpstrCommand As String, ByVal lpstrReturnString As String, ByVal uReturnLength As Long, ByVal hwndCallback As Long) As Long
Private Declare Function mciGetErrorString Lib "winmm.dll" Alias "mciGetErrorStringA" (ByVal dwError As Long, ByVal lpBuffer As String, ByVal uLength As Long) As Long

Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long

Private Const WM_SETHOTKEY As Long = &H32&

Private Const VK_F1 As Long = &H70&
Private Const VK_F2 As Long = &H71&
Private Const VK_F3 As Long = &H72&
Private Const VK_F4 As Long = &H73&
' etc.

' CopyMemory, my best friend ;-)
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)

Private Declare Function GetLastError Lib "kernel32.dll" () As Long

'**********************************
' Event handlers.
'**********************************

Private Sub Form_Load()
    
    ' Hotkey fr die Anwendung registrieren, in diesem Fall F4.
    Call SendMessage(Me.hWnd, WM_SETHOTKEY, VK_F4, 0&)
    
    ' Initialisierung der Steuerelemente.
    Me.cmdOpen.Enabled = False
    Me.cmdClose.Enabled = False
    Call EnumDrives
    Call UpdateDriveList
    If Me.lstDrives.ListCount = 0 Then
        Call MsgBox("No CD-ROm drives found, quitting!", vbExclamation, App.Title)
        Call Unload(Me)
        Exit Sub
    Else
        Me.lstDrives.ListIndex = 0
    End If
    Call Me.Move((Screen.Width - Me.Width) * 0.5, (Screen.Height - Me.Height) * 0.5)
    Me.WindowState = vbMinimized
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If UnloadMode = vbFormControlMenu Then
        Me.WindowState = vbMinimized
        Cancel = Not Cancel     ' Kleiner Trick ;-)
    End If
End Sub

Private Sub cmdClose_Click()
    Me.WindowState = vbMinimized
    Call CloseDoor(Chr$(Me.lstDrives.ItemData(Me.lstDrives.ListIndex)) & ":")
    Me.cmdClose.Enabled = False
    Me.cmdOpen.Enabled = True
End Sub

Private Sub cmdOpen_Click()
    Me.WindowState = vbMinimized
    Call OpenDoor(Chr$(Me.lstDrives.ItemData(Me.lstDrives.ListIndex)) & ":")
    Me.cmdOpen.Enabled = True
    Me.cmdClose.Enabled = True
End Sub

Private Sub lstDrives_Click()
    If IsDriveOpen(Chr$(Me.lstDrives.ItemData(Me.lstDrives.ListIndex)) & ":") Then
        Me.cmdOpen.Enabled = True
        Me.cmdClose.Enabled = True
    Else
        Me.cmdOpen.Enabled = True
        Me.cmdClose.Enabled = False
    End If
End Sub

Private Sub tmrTimer_Timer()
    Call UpdateDriveList
End Sub

'**********************************
' Private procedures.
'**********************************

'
' Ermittelt die Datentrgerbezeichnung eines Laufwerks.
'
Private Function GetDriveName(ByRef Drive As String) As String
    Dim s As String
    s = Space$(256)
    Dim t As String
    t = Space$(256)
    Dim n As Long
    n = GetVolumeInformation(Drive, s, Len(s), 0&, 0&, 0&, t, Len(t))
    If n = 0 Then
        
        ' OK, man knnte hier auch noch schnell den dazugehrigen Fehlertext ermitteln.
        Call MsgBox("Es ist der Systemfehler mit der Nummer " & GetLastError & " aufgetreten!")
    End If
    GetDriveName = Left$(s, InStr(s, Chr$(0)) - 1)
End Function

'
' Fgt fr jedes Steuerelement einen Eintrag der ListBox hinzu.
'
Private Sub EnumDrives()
    Dim l As Long, lngRet As Long, k As Long, DriveType As Long
    Dim Buffer As String, Drives As String, Drive As String
    Call Me.lstDrives.Clear
    Buffer = Space(64)
    l = 64
    lngRet = GetLogicalDriveStrings(l, Buffer)
    Drives = Left$(Buffer, lngRet)
    Do While k < Len(Buffer)
        k = InStr(Buffer, Chr$(0))
        If k Then
            Drive = Left$(Buffer, k)
            Buffer = Mid$(Buffer, k + 1, Len(Buffer))
            DriveType = GetDriveType(Drive)
            If DriveType = 5 Then
                Call Me.lstDrives.AddItem("")
                Me.lstDrives.ItemData(Me.lstDrives.NewIndex) = Asc(Drive)
            End If
        Else
            Exit Do
        End If
    Loop
End Sub

'
' Aktualisiert die Liste mit den Laufwerken.
'
Private Sub UpdateDriveList()
    Dim Drive As String
    Dim i As Integer
    
    ' Updaten der Laufwerksliste. Dabei werden nicht alle Elemente gelscht und danach die neuen hinzugefgt,
    ' sondern nur die nicht mehr vorhandenen entfernt und neue hinzugefgt. Dadurch bleibt eine eventuell
    ' vorhandene Auswahl bestehen und es fhrt nicht zu einer Deselektion des Steuerelements.
    For i = 0 To Me.lstDrives.ListCount - 1
        Drive = Chr$(Me.lstDrives.ItemData(i)) & ":"
        If IsDriveOpen(Drive) Then
            Drive = UCase(Mid$(Drive, 1, 1)) & ":" & vbTab & "(empty or open)"
            If i = Me.lstDrives.ListIndex Then
                Me.cmdOpen.Enabled = True
                Me.cmdClose.Enabled = True
            End If
        Else
            Drive = UCase(Mid$(Drive, 1, 1)) & ":" & vbTab & GetDriveName(Drive)
            If i = Me.lstDrives.ListIndex Then
                Me.cmdOpen.Enabled = True
                Me.cmdClose.Enabled = False
            End If
        End If
        If Me.lstDrives.List(i) <> Drive Then
            Me.lstDrives.List(i) = Drive
        End If
    Next i
End Sub

'
' Gibt True zurck, wenn ein Laufwerk offen oder leer ist, sonst False.
'
Private Function IsDriveOpen(ByRef Drive As String) As Boolean
    On Error Resume Next
    
    ' Versuchen, das Current Directory auf das angegebene Laufwerk zu setzen.
    Dim s As String
    s = CurDir
    Call ChDir(Drive)
    
    ' Wenn ein Fehler dabei auftrat, dann ist liegt sicher kein Datentrger darin.
    IsDriveOpen = (Err.Number > 0)
    
    ' Ein wenig Clean-Up-Code...
    If IsDriveOpen Then
        Call Err.Clear
        Call ChDir(s)
    End If
End Function

'
' Schliesst das Laufwerk mit dem angegebenen Laufwerksbuchstaben ('DriveLetter' ist ein Zeichen).
'
Private Sub CloseDoor(ByVal DriveLetter As String)
    Dim n As Long
    n = mciSendString("open " & DriveLetter & ": alias MyAlias type cdaudio shareable", vbNullString, 0&, 0&)
    If n <> 0 Then
        Call HandleMCIError(LOWORD(n))
    End If
    n = mciSendString("set MyAlias door closed", vbNullString, 0&, 0&)
    If n <> 0 Then
        Call HandleMCIError(LOWORD(n))
    End If
    n = mciSendString("close MyAlias", vbNullString, 0&, 0&)
    If n <> 0 Then
        Call HandleMCIError(LOWORD(n))
    End If
End Sub

'
' ffnet das Laufwerk mit dem angegebenen Laufwerksbuchstaben ('DriveLetter' ist ein Zeichen).
'
Private Sub OpenDoor(ByVal DriveLetter As String)
    Dim n As Long
    n = mciSendString("open " & DriveLetter & ": alias MyAlias type cdaudio shareable", vbNullString, 0&, 0&)
    If n <> 0 Then
        Call HandleMCIError(LOWORD(n))
    End If
    n = mciSendString("set MyAlias door open", vbNullString, 0&, 0&)
    If n <> 0 Then
        Call HandleMCIError(LOWORD(n))
    End If
    n = mciSendString("close MyAlias", vbNullString, 0&, 0&)
    If n <> 0 Then
        Call HandleMCIError(LOWORD(n))
    End If
End Sub

'
' Gibt die Fehlermeldung zu einem MCI-Fehler aus.
'
Private Sub HandleMCIError(ByVal ErrorNumber As Long)
    Dim s As String
    s = Space$(128)
    If mciGetErrorString(ErrorNumber, s, Len(s)) = 1 Then
        Call MsgBox("An MCI error occured:  " & s)
    Else
        Call MsgBox("An unknown MCI error occured!")
    End If
End Sub

'
' Returns the low 16-bit integer from a 32-bit long integer.
'
Public Function LOWORD(ByVal dwValue As Long) As Integer
    Call CopyMemory(LOWORD, dwValue, 2&)
End Function

'
' Returns the high 16-bit integer from a 32-bit long integer.
'
Public Function HIWORD(ByVal dwValue As Long) As Integer
    Call CopyMemory(HIWORD, ByVal VarPtr(dwValue) + 2, 2&)
End Function
